## msopenh264 1.2.1~git20211104.9352c50

=== CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

cmake_minimum_required(VERSION 3.0)
project(msopenh264 VERSION 1.2.1 LANGUAGES CXX)


set(PACKAGE "${PROJECT_NAME}")
set(PACKAGE_NAME "${PROJECT_NAME}")
set(PACKAGE_VERSION "${PROJECT_VERSION}")
set(PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
set(PACKAGE_BUGREPORT "support@belledonne-communications.com")
set(PACKAGE_TARNAME "msopenh264")
set(PACKAGE_URL "")
set(VERSION "${PACKAGE_VERSION}")


option(ENABLE_SHARED "Build shared library." YES)
option(ENABLE_STATIC "Build static library." YES)
option(ENABLE_DECODER "Enable the openh264 decoder" Yes)

include(GNUInstallDirs)

if(NOT CMAKE_INSTALL_RPATH AND CMAKE_INSTALL_PREFIX)
	set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR})
	message(STATUS "Setting install rpath to ${CMAKE_INSTALL_RPATH}")
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(CheckIncludeFileCXX)
check_include_file_cxx("stdbool.h" HAVE_STDBOOL_H)

find_package(Mediastreamer2 CONFIG REQUIRED)
find_package(ortp CONFIG REQUIRED)
find_package(bctoolbox CONFIG REQUIRED)

find_package(OpenH264 REQUIRED)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

include_directories(
	${MEDIASTREAMER2_INCLUDE_DIRS}
	${OPENH264_INCLUDE_DIRS}
	src
	${CMAKE_CURRENT_BINARY_DIR}
	${CMAKE_CURRENT_BINARY_DIR}/src
)

add_definitions(-DHAVE_CONFIG_H -std=c++11)

if(NOT MSVC)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wno-error=unknown-pragmas")
	if(CMAKE_C_COMPILER_ID MATCHES "Clang")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-error=unknown-warning-option")
		if(NOT IOS)
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror -Wextra")
		endif()
	elseif(CMAKE_C_COMPILER_ID STREQUAL "GNU")
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror -Wextra -Wno-error=pragmas")
	endif()
endif()

add_subdirectory(src)


# CPack settings
set(CPACK_PACKAGE_NAME "msopenh264")
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}")
set(CPACK_SOURCE_IGNORE_FILES
        "^${CMAKE_BINARY_DIR}"
        "/\\\\..+"
)

include(CPack)

=== src/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

set(LIBS
	${MEDIASTREAMER2_LIBRARIES}
	${ORTP_LIBRARIES}
	${OPENH264_LIBRARIES}
	${BCTOOLBOX_CORE_LIBRARIES}
)

set(SOURCE_FILES
	msopenh264.cpp
	msopenh264dec.cpp
	msopenh264enc.cpp
)

if(ENABLE_DECODER)
	add_definitions(-DOPENH264_DECODER_ENABLED)
endif()

set(MS2_PLUGINS_DIR "${MEDIASTREAMER2_PLUGINS_LOCATION}")

if(ENABLE_STATIC)
	add_library(msopenh264-static STATIC ${SOURCE_FILES})
	set_target_properties(msopenh264-static PROPERTIES OUTPUT_NAME msopenh264)
	target_link_libraries(msopenh264-static ${LIBS})
	install(TARGETS msopenh264-static
		ARCHIVE DESTINATION "${MS2_PLUGINS_DIR}"
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	)
endif()
if(ENABLE_SHARED)
	if(NOT APPLE)
		add_library(msopenh264 MODULE ${SOURCE_FILES})
	else()
		add_library(msopenh264 SHARED ${SOURCE_FILES})
	endif()
	target_link_libraries(msopenh264 ${LIBS})
	if(APPLE)
		if(IOS)
			set(MIN_OS ${LINPHONE_IOS_DEPLOYMENT_TARGET})
		else()
			set(MIN_OS ${CMAKE_OSX_DEPLOYMENT_TARGET})
		endif()

		set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/build/osx/")
		set_target_properties(msopenh264 PROPERTIES
			FRAMEWORK TRUE
			MACOSX_FRAMEWORK_IDENTIFIER org.linphone.msopenh264
  			MACOSX_FRAMEWORK_INFO_PLIST Info.plist.in
		) 
	endif()
	if(MSVC)
		if(CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
			install(FILES $<TARGET_PDB_FILE:msopenh264>
				DESTINATION ${CMAKE_INSTALL_BINDIR}
				PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
			)
		endif()
		set_target_properties(msopenh264 PROPERTIES PREFIX "lib")
	endif()
	install(TARGETS msopenh264
		RUNTIME DESTINATION "${MS2_PLUGINS_DIR}"
		LIBRARY DESTINATION "${MS2_PLUGINS_DIR}"
		ARCHIVE DESTINATION "${MS2_PLUGINS_DIR}"
		FRAMEWORK DESTINATION Frameworks
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	)
endif()

=== debian/changelog ===
msopenh264 (1.2.1~git20211104.9352c50-2) unstable; urgency=medium

  * Source-only upload.

 -- Bernhard Schmidt <berni@debian.org>  Mon, 28 Nov 2022 10:54:21 +0100

msopenh264 (1.2.1~git20211104.9352c50-1) unstable; urgency=low

  [ Dennis Filder ]
  * New upstream release 1.2.1~git20211104.9352c50
  * Initial packaging.

 -- Bernhard Schmidt <berni@debian.org>  Wed, 12 Oct 2022 18:08:09 +0200

=== debian/control ===
Source: msopenh264
Section: video
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Bernhard Schmidt <berni@debian.org>,
Build-Depends: debhelper-compat (= 13),
 cmake,
 libmediastreamer-dev,
 libopenh264-dev (>= 2.3.1~),
Rules-Requires-Root: no
Standards-Version: 4.6.1
Homepage: https://gitlab.linphone.org/BC/public/msopenh264
Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/msopenh264.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/msopenh264

Package: mediastreamer2-plugin-openh264
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: OpenH264 plugin for Mediastreamer2 (plugin)
 This package contains a plugin for the Mediastreamer2 streaming
 framework enabling the use of the OpenH264 codec.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- -DCMAKE_SKIP_RPATH=ON -DENABLE_STATIC=OFF

# Disable dh_auto{reconf,tools_update_config} as we only use cmake.
override_dh_autoreconf:
override_dh_autotools_update_config:

## msopenh264 5.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -78,6 +78,10 @@
 	elseif(CMAKE_C_COMPILER_ID STREQUAL "GNU")
 		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror -Wextra -Wno-error=pragmas")
 	endif()
+else()
+	if(CMAKE_SYSTEM_NAME STREQUAL "WindowsStore")
+		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /ZW /EHsc /await")
+	endif()
 endif()
 
 add_subdirectory(src)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -77,6 +77,10 @@
 			)
 		endif()
 		set_target_properties(msopenh264 PROPERTIES PREFIX "lib")
+		if(CMAKE_SYSTEM_NAME STREQUAL "WindowsStore")
+			set_target_properties(msopenh264 PROPERTIES VS_WINRT_COMPONENT TRUE)
+		endif()
+	
 	endif()
 	install(TARGETS msopenh264
 		RUNTIME DESTINATION "${MS2_PLUGINS_DIR}"

=== debian/changelog ===
msopenh264 (5.2.0-2build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:57:58 +1100

msopenh264 (5.2.0-2build2) noble; urgency=medium

  * Rebuild against new libmediastreamer13t64.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 26 Mar 2024 07:46:50 +0100

msopenh264 (5.2.0-2build1) noble; urgency=medium

  * No-change rebuild against libbctoolbox1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 03:00:55 +0000

msopenh264 (5.2.0-2) unstable; urgency=medium

  * Release to unstable.

 -- Bernhard Schmidt <berni@debian.org>  Sat, 29 Jul 2023 22:08:41 +0200

msopenh264 (5.2.0-1) experimental; urgency=medium

  * New upstream release 5.2.0.
  * Comply with Debian policy v4.6.2.

 -- Dennis Filder <d.filder@web.de>  Mon, 19 Dec 2022 20:29:18 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: msopenh264
 Section: video
 Priority: optional
-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders: Bernhard Schmidt <berni@debian.org>,
 Build-Depends: debhelper-compat (= 13),
  cmake,
- libmediastreamer-dev,
+ libmediastreamer-dev (>= 5.2.0~),
  libopenh264-dev (>= 2.3.1~),
 Rules-Requires-Root: no
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://gitlab.linphone.org/BC/public/msopenh264
 Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/msopenh264.git
 Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/msopenh264

=== debian/watch ===
# last tagged release was 1.2.1 (2017-07-20), so follow master/HEAD
version=4
opts=\
mode=git,\
pgpmode=none,\
pretty=1.2.1~git%cd.%h,\
compression=xz \
  https://gitlab.linphone.org/BC/public/msopenh264.git \
  HEAD

## msopenh264 5.2.0%2Bgit20240521.041b07a

=== debian/watch ===
# last tagged release was 5.2.0, so follow master/HEAD
version=4
opts=\
mode=git,\
pgpmode=none,\
pretty=5.2.0+git%cd.%h,\
compression=xz \
  https://gitlab.linphone.org/BC/public/msopenh264.git \
  HEAD

## msopenh264 5.2.0+git20240521.041b07a

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ############################################################################
 # CMakeLists.txt
-# Copyright (C) 2014  Belledonne Communications, Grenoble France
+# Copyright (C) 2014-2023  Belledonne Communications, Grenoble France
 #
 ############################################################################
 #
@@ -21,8 +21,9 @@
 ############################################################################
 
 cmake_minimum_required(VERSION 3.0)
-project(msopenh264 VERSION 1.2.1 LANGUAGES CXX)
+project(MSOpenH264 VERSION 1.2.1 LANGUAGES CXX)
 
+set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib/mediastreamer2/plugins")
 
 set(PACKAGE "${PROJECT_NAME}")
 set(PACKAGE_NAME "${PROJECT_NAME}")
@@ -34,9 +35,7 @@
 set(VERSION "${PACKAGE_VERSION}")
 
 
-option(ENABLE_SHARED "Build shared library." YES)
-option(ENABLE_STATIC "Build static library." YES)
-option(ENABLE_DECODER "Enable the openh264 decoder" Yes)
+option(ENABLE_DECODER "Enable the openh264 decoder" ON)
 
 include(GNUInstallDirs)
 
@@ -45,28 +44,15 @@
 	message(STATUS "Setting install rpath to ${CMAKE_INSTALL_RPATH}")
 endif()
 
-list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
+list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
 
 include(CheckIncludeFileCXX)
 check_include_file_cxx("stdbool.h" HAVE_STDBOOL_H)
 
-find_package(Mediastreamer2 CONFIG REQUIRED)
-find_package(ortp CONFIG REQUIRED)
-find_package(bctoolbox CONFIG REQUIRED)
-
+find_package(Mediastreamer2 5.3.0 REQUIRED)
 find_package(OpenH264 REQUIRED)
 
-configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
-
-include_directories(
-	${MEDIASTREAMER2_INCLUDE_DIRS}
-	${OPENH264_INCLUDE_DIRS}
-	src
-	${CMAKE_CURRENT_BINARY_DIR}
-	${CMAKE_CURRENT_BINARY_DIR}/src
-)
-
-add_definitions(-DHAVE_CONFIG_H -std=c++11)
+configure_file("${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake" "${CMAKE_CURRENT_BINARY_DIR}/config.h")
 
 if(NOT MSVC)
 	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wno-error=unknown-pragmas")

=== src/CMakeLists.txt ===
############################################################################
# CMakeLists.txt
# Copyright (C) 2014-2023  Belledonne Communications, Grenoble France
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
############################################################################

set(SOURCE_FILES
	msopenh264.cpp
	msopenh264dec.cpp
	msopenh264enc.cpp
)

if(BUILD_SHARED_LIBS)
	if(APPLE)
		add_library(msopenh264 SHARED ${SOURCE_FILES})
	else()
		add_library(msopenh264 MODULE ${SOURCE_FILES})
	endif()
else()
	add_library(msopenh264 STATIC ${SOURCE_FILES})
endif()
target_compile_options(msopenh264 PRIVATE "-std=c++11")
target_compile_definitions(msopenh264 PRIVATE "HAVE_CONFIG_H")
if(ENABLE_DECODER)
	target_compile_definitions(msopenh264 PRIVATE "OPENH264_DECODER_ENABLED")
endif()
target_include_directories(msopenh264 PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}
	${PROJECT_BINARY_DIR}
	${CMAKE_CURRENT_BINARY_DIR}
)
target_link_libraries(msopenh264 PRIVATE ${Mediastreamer2_TARGET} ${OpenH264_TARGET})

if(BUILD_SHARED_LIBS)
	if(APPLE)
		set_target_properties(msopenh264 PROPERTIES
			FRAMEWORK TRUE
			MACOSX_FRAMEWORK_IDENTIFIER org.linphone.msopenh264
			MACOSX_FRAMEWORK_INFO_PLIST "${PROJECT_SOURCE_DIR}/build/osx/Info.plist.in"
		) 
	endif()
	if(MSVC)
		install(FILES $<TARGET_PDB_FILE:msopenh264>
			DESTINATION ${CMAKE_INSTALL_BINDIR}
			PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
			CONFIGURATIONS Debug RelWithDebInfo
		)
		set_target_properties(msopenh264 PROPERTIES PREFIX "lib")
		if(CMAKE_SYSTEM_NAME STREQUAL "WindowsStore")
			set_target_properties(msopenh264 PROPERTIES VS_WINRT_COMPONENT TRUE)
		endif()
	
	endif()
endif()


install(TARGETS msopenh264
	RUNTIME DESTINATION "${Mediastreamer2_PLUGINS_DIR}"
	LIBRARY DESTINATION "${Mediastreamer2_PLUGINS_DIR}"
	ARCHIVE DESTINATION "${Mediastreamer2_PLUGINS_DIR}"
	FRAMEWORK DESTINATION Frameworks
	PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

=== debian/changelog ===
msopenh264 (5.2.0+git20240521.041b07a-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fix for FTBFS with CMake 4. (Closes: #1113299)

 -- Adrian Bunk <bunk@debian.org>  Sat, 11 Oct 2025 15:54:27 +0300

msopenh264 (5.2.0+git20240521.041b07a-2) unstable; urgency=medium

  * Build shared library. (Closes: #1099079)

 -- Bastian Germann <bage@debian.org>  Fri, 28 Feb 2025 08:58:09 +0100

msopenh264 (5.2.0+git20240521.041b07a-1) unstable; urgency=medium

  * Team upload.
  * d/watch: Scan for newer versions.
  * New upstream snapshot 5.2.0+git20240521.041b07a.

 -- Bastian Germann <bage@debian.org>  Wed, 26 Feb 2025 22:35:19 +0100

msopenh264 (5.2.0-3) experimental; urgency=medium

  * Add shlibs.local entry for libortp with version tightened to the one
    that links with the same libbctoolbox that
    mediastreamer2-plugin-openh264 links with.

 -- Dennis Filder <d.filder@web.de>  Thu, 05 Oct 2023 21:37:10 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: msopenh264
 Section: video
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
+Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders: Bernhard Schmidt <berni@debian.org>,
 Build-Depends: debhelper-compat (= 13),
  cmake,
- libmediastreamer-dev (>= 5.2.0~),
+ libmediastreamer-dev (>= 5.2.98~),
  libopenh264-dev (>= 2.3.1~),
 Rules-Requires-Root: no
 Standards-Version: 4.6.2

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 	dh $@ --buildsystem=cmake
 
 override_dh_auto_configure:
-	dh_auto_configure --buildsystem=cmake -- -DCMAKE_SKIP_RPATH=ON -DENABLE_STATIC=OFF
+	dh_auto_configure --buildsystem=cmake -- -DCMAKE_SKIP_RPATH=ON -DBUILD_SHARED_LIBS=ON
 
 # Disable dh_auto{reconf,tools_update_config} as we only use cmake.
 override_dh_autoreconf:
